# coding: utf-8

"""
    Maxar Content API - Catalog

    The Maxar Content Catalog API implements a STAC-compliant service for searching the Maxar content catalog.  __The STAC specification is still under development.  When version 1.0 of the STAC specification is released the Content Catalog API will be updated to reflect any changes, some of which will not be backward compatible with this current version.__  For information on STAC see [stacspec.org](https://stacspec.org)   # noqa: E501

    OpenAPI spec version: 0.9
    Contact: DL-Content-Catalog@maxar.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from maxarcat_client.api_client import ApiClient


class STACITEMApi(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def get_item_stac(self, collection_id, item_id, **kwargs):  # noqa: E501
        """Get STAC item  # noqa: E501

        For authorization this method requires the use of a valid bearer token.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_item_stac(collection_id, item_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str collection_id: Identifier (name) of a specific collection (required)
        :param str item_id: STAC item ID (required)
        :return: Item
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_item_stac_with_http_info(collection_id, item_id, **kwargs)  # noqa: E501
        else:
            (data) = self.get_item_stac_with_http_info(collection_id, item_id, **kwargs)  # noqa: E501
            return data

    def get_item_stac_with_http_info(self, collection_id, item_id, **kwargs):  # noqa: E501
        """Get STAC item  # noqa: E501

        For authorization this method requires the use of a valid bearer token.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_item_stac_with_http_info(collection_id, item_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str collection_id: Identifier (name) of a specific collection (required)
        :param str item_id: STAC item ID (required)
        :return: Item
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['collection_id', 'item_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_item_stac" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'collection_id' is set
        if ('collection_id' not in params or
                params['collection_id'] is None):
            raise ValueError("Missing the required parameter `collection_id` when calling `get_item_stac`")  # noqa: E501
        # verify the required parameter 'item_id' is set
        if ('item_id' not in params or
                params['item_id'] is None):
            raise ValueError("Missing the required parameter `item_id` when calling `get_item_stac`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'collection_id' in params:
            path_params['collectionId'] = params['collection_id']  # noqa: E501
        if 'item_id' in params:
            path_params['itemId'] = params['item_id']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/geo+json', 'application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['bearer']  # noqa: E501

        return self.api_client.call_api(
            '/collections/{collectionId}/items/{itemId}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='Item',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_items_stac(self, collection_id, **kwargs):  # noqa: E501
        """Search STAC items in a collection.  # noqa: E501

        The same query parameters may be used as those in the /search endpoint, except for \"collections\" since the collection to search is part of the URL path.  For authorization this method requires the use of a valid bearer token.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_items_stac(collection_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str collection_id: Identifier (name) of a specific collection (required)
        :param str bbox: Bounding box in format \"west,south,east,north\" in WGS84 decimal degrees. When performing a spatial search specify either of the parameters \"bbox\" of \"intesects\", but not both. 
        :param str search_datetime: Date range filter in format \"start-date/end-date\"
        :param str ids: Comma-separated list of STAC item IDs to return.  The items returned are still subject to whatever other search filters are specified. 
        :param str intersects: GeoJSON geometry to search by.  Only STAC items whose geometries intersect this geometry are selected. When performing a spatial search specify either of the parameters \"bbox\" of \"intesects\", but not both. 
        :param str where: SQL-style WHERE clause for filtering STAC items by properties.  You can filter on any property inside a STAC item's \"properties\" object.  While STAC items have a \"datetime\" property you should use the search operation's \"datetime\" parameter for searching by it, and not use the \"where\" parameter for searching by datetime. 
        :param str orderby: SQL-style ORDER BY clause.  The only properties results can be ordered by are \"id\" and \"datetime\". You can use ASC and DESC modifiers on each column.  If not specified then orderby defaults to \"datetime DESC, id ASC\". 
        :param int limit: Maximum number of items to return
        :param int page: Page number to retrieve.  First page is numbered 1. 
        :return: ItemCollection
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_items_stac_with_http_info(collection_id, **kwargs)  # noqa: E501
        else:
            (data) = self.get_items_stac_with_http_info(collection_id, **kwargs)  # noqa: E501
            return data

    def get_items_stac_with_http_info(self, collection_id, **kwargs):  # noqa: E501
        """Search STAC items in a collection.  # noqa: E501

        The same query parameters may be used as those in the /search endpoint, except for \"collections\" since the collection to search is part of the URL path.  For authorization this method requires the use of a valid bearer token.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_items_stac_with_http_info(collection_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str collection_id: Identifier (name) of a specific collection (required)
        :param str bbox: Bounding box in format \"west,south,east,north\" in WGS84 decimal degrees. When performing a spatial search specify either of the parameters \"bbox\" of \"intesects\", but not both. 
        :param str search_datetime: Date range filter in format \"start-date/end-date\"
        :param str ids: Comma-separated list of STAC item IDs to return.  The items returned are still subject to whatever other search filters are specified. 
        :param str intersects: GeoJSON geometry to search by.  Only STAC items whose geometries intersect this geometry are selected. When performing a spatial search specify either of the parameters \"bbox\" of \"intesects\", but not both. 
        :param str where: SQL-style WHERE clause for filtering STAC items by properties.  You can filter on any property inside a STAC item's \"properties\" object.  While STAC items have a \"datetime\" property you should use the search operation's \"datetime\" parameter for searching by it, and not use the \"where\" parameter for searching by datetime. 
        :param str orderby: SQL-style ORDER BY clause.  The only properties results can be ordered by are \"id\" and \"datetime\". You can use ASC and DESC modifiers on each column.  If not specified then orderby defaults to \"datetime DESC, id ASC\". 
        :param int limit: Maximum number of items to return
        :param int page: Page number to retrieve.  First page is numbered 1. 
        :return: ItemCollection
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['collection_id', 'bbox', 'search_datetime', 'ids', 'intersects', 'where', 'orderby', 'limit', 'page']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_items_stac" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'collection_id' is set
        if ('collection_id' not in params or
                params['collection_id'] is None):
            raise ValueError("Missing the required parameter `collection_id` when calling `get_items_stac`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'collection_id' in params:
            path_params['collectionId'] = params['collection_id']  # noqa: E501

        query_params = []
        if 'bbox' in params:
            query_params.append(('bbox', params['bbox']))  # noqa: E501
        if 'search_datetime' in params:
            query_params.append(('datetime', params['search_datetime']))  # noqa: E501
        if 'ids' in params:
            query_params.append(('ids', params['ids']))  # noqa: E501
        if 'intersects' in params:
            query_params.append(('intersects', params['intersects']))  # noqa: E501
        if 'where' in params:
            query_params.append(('where', params['where']))  # noqa: E501
        if 'orderby' in params:
            query_params.append(('orderby', params['orderby']))  # noqa: E501
        if 'limit' in params:
            query_params.append(('limit', params['limit']))  # noqa: E501
        if 'page' in params:
            query_params.append(('page', params['page']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/geo+json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['bearer']  # noqa: E501

        return self.api_client.call_api(
            '/collections/{collectionId}/items', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='ItemCollection',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)
